/*******************
** Eldarea MUDLib **
********************
**
** filename - short desc
**
** CVS DATA
** $Date: 1999/11/05 12:30:47 $
** $Revision: 1.1.1.1 $
**
** longdesc
**
** CVS History
**
** $Log: container.h,v $
** Revision 1.1.1.1  1999/11/05 12:30:47  elatar
** Preparing mudlib for cvs control
**
**
*/
// MorgenGrauen MUDlib
//
// CONTAINER.H -- container header
//
// $Date: 1999/11/05 12:30:47 $
// $Revision: 1.1.1.1 $
/* $Log: container.h,v $
/* Revision 1.1.1.1  1999/11/05 12:30:47  elatar
/* Preparing mudlib for cvs control
/*
/* Revision 1.1.1.1  1999/11/04 12:48:15  en
/* MUDLib CVS Preperation
/*
 * Revision 1.8  1997/10/28 12:19:33  Bongo
 * make_invlist ist nun varargs mit neuem Parameter extra
 *
 * Revision 1.7  1997/09/12 15:40:10  Fiona
 * P_BULKINESS_CONTENTS
 *
 * Revision 1.6  1997/08/17 12:56:42  Fiona
 * P_BULKINESS
 *
 * Revision 1.5  1997/07/29 23:38:41  Gum
 * present_objects und locate_objects um den parameter exclude erweitert,
 * um einen bug in /std/living/put_and_get fixen zu koennen
 *
 * Revision 1.4  1996/10/15 17:34:46  gum
 * P_CNT_KEY_CLOSE, P_CNT_FLAGS und P_ONLY_LOCK eingefuegt
 *
 * Revision 1.3  1994/11/23  14:39:57  Troy
 * Added P_CNT_KEY
 *
 * Revision 1.2  1994/10/21  18:50:15  mud
 * Neue MG-Release
 *
 * Revision 1.4  1994/09/23  20:43:20  Hate
 * removed P_WEIGHT & P_TOTAL_WEIGHT
 *
 * Revision 1.3  1994/01/18  01:05:19  mud
 * *** empty log message ***
 *
 * Revision 1.3  1994/01/18  01:05:19  mud
 * *** empty log message ***
 *
 * Revision 1.2  1994/01/08  10:58:49  mud
 * *** empty log message ***
 *
 * Revision 1.1  1994/01/06  10:59:33  mud
 * Initial revision
 *
 */
 
#ifndef __CONTAINER_H__
#define __CONTAINER_H__

#include <thing/restrictions.h>

// properties

#define P_MAX_WEIGHT 			"max_weight"
#define P_CONTENTS   			"contents"
#define P_CNT_STATUS 			"cnt_status"
#define P_TRANSPARENT			"transparent"
#define P_CNT_KEY                       "cnt_key"
#define P_CNT_KEY_CLOSE                 "cnt_key_close"
#define P_CNT_FLAGS                     "cnt_flags"
#ifndef P_BULKINESS
#define P_BULKINESS             "bulkiness"
#endif
#define P_MAX_BULKINESS         "max_bulkiness"
#define P_BULKINESS_CONTENTS    "bulkiness_contents"

// special defines
#define CNT_STATUS_OPEN   0
#define CNT_STATUS_CLOSED 1
#define CNT_STATUS_LOCKED 2

#define CNT_RESET_OPEN 1        // wird bei reset geoeffnet
#define CNT_RESET_CLOSED 2      // wird bei reset geschlossen
#define CNT_RESET_LOCKED 4      // wird bei reset abgeschlossen
#define CNT_ONLY_LOCK 8         // kann vom offenen Zustand nur abgeschlossen
                                // werden
#define R_INSERT "insert"

#endif // __CONTAINER_H__

#ifdef NEED_PROTOTYPES

#ifndef __CONTAINER_H_PROTO__
#define __CONTAINER_H_PROTO__

// prototypes
// from: container/description.c
varargs string make_invlist(object viewer, mixed inv, mixed extra);

// from: container/restrictions.c
int query_weight_contents();

varargs int MayAddWeight(int w);
int MayAddBulkiness(int w);
varargs int PreventInsert(object ob);
object *present_objects(string complex_desc, object *exclude);
object *locate_objects(string complex_desc, int info, object *exclude);

#endif // __CONTAINER_H_PROTO__

#endif // NEED_PROTOTYPES
