/*******************
** Eldarea MUDLib **
********************
**
** filename - short desc
**
** CVS DATA
** $Date: 1999/11/05 12:30:47 $
** $Revision: 1.1.1.1 $
**
** longdesc
**
** CVS History
**
** $Log: guilds.h,v $
** Revision 1.1.1.1  1999/11/05 12:30:47  elatar
** Preparing mudlib for cvs control
**
**
*/
// Wunderland Mudlib 
//
// SYS/GUILDS.H - Definitionen fur /std/guild.c
//
// Autoren: Andara & Arachna Tue Okt 18 1994
//
// Based on Morgengrauen-Mudlib
//
// $Log: guilds.h,v $
// Revision 1.1.1.1  1999/11/05 12:30:47  elatar
// Preparing mudlib for cvs control
//
// Revision 1.1.1.1  1999/11/04 12:48:15  en
// MUDLib CVS Preperation
//
// Revision 1.11  1998/10/27 00:11:00  Elric
// NEED_PROTOTYPES wieder aktiviert
//
// Revision 1.10  1998/10/15 14:26:31  Elric
// Aenderungen fuer das neue Statsystem
//
 
#ifndef __GUILD_SKILLS_H__
#define __GUILD_SKILLS_H__
 
/* properties and constants*/
 
#define GM	"/secure/guildmaster"
#define QM	"/secure/questmaster"
#define EM      "/secure/exploremaster"
#define STDGUILD "/std/guild"
 
#define GM_NAME 0
#define GM_WIZ  1
#define GM_STAT 2

#define MAX_LEVEL 35
 
#define P_GUILD_NAME    "guild_name"
/*	String, Name der Gilde, sollte gleich dem Namen sein,
 *	der dem GuildMaster uebergeben wird
 */
 
#define P_JOIN_COST    "join_cost"
/*	Kosten, um in die Gilde aufgenommen zu werden (Geld)	*/
 
#define P_MIN_LEVEL     "min_level"
/*	Level, welches man mindestens braucht, um in die Gilde aufgenommen zu werden */
 
#define P_MIN_STATS     "min_stats"
/*	minimale Stats, um in die Gilde aufgenommen zu werden
 *	array mit 4 Elementen ({A_INT, A_STR, A_DEX, A_CON})
 */

#define P_GUILD_STATMODS "guild_statmods"
/*    Die Statmodifikatoren der Gilde
 *    Mapping: ([A_INT : 0, A_DEX : 0, A_STR : 0, A_CON : 0])
 */
 
#define P_GUILD_SKILLS  "guild_skills"
/*	Feld, das die Namen der Spells/Skills enthaelt, die diese Gilde vergeben darf */
 
#define P_GUILD_TITLES  "guild_titles"
/*	Feld: 1. Index: Gender, 2. Index: Level
 *	Werte: Titel die die Gilde pro Level an ihre Mitglieder vergibt
 */
 
#define P_GUILD_EXP     "guild_exp"
/*	Feld: Index: Level
 *	Werte: Notwendige Erfahrungspunkte, um das Level zu steigern
 */
 
#define P_GUILD_QUESTS "guild_quests"
/*	Feld das die Namen der Quests enthaelt, die keine AP bringen, aber
 *	zur Aufnahme oder zum Erhoehen geloest werden muessen
 */
 
#define P_GUILD_FACTOR "guild_factors"
/*	Feld, das es der Gilde ermoeglicht, die Kosten fuer das Erhoehen von Stats
 *      (aber nur bei gekauften Stats) auch von der Gilde abhaengig zu machen,
 *      und nicht nur von der Rasse des Spielers
 */
#define P_GUILD_OBJECT "guild_object"
/*      String der die Gilde enthaelt, zu der das Objekt gehoert. Ist nur fuer
 *      echte Gildenobjekte (Behueterschwert, Sonnebrille, MK-Robe etc.)
 */

 
#endif // __GUILD_SKILLS_H__
 
#ifdef NEED_PROTOTYPES
 
#ifndef __GUILD_SKILLS_H_PROTO__
#define __GUILD_SKILLS_H_PROTO__
 
/* functions */
 
 
void create();
void init();
int banish(string str);
string QueryTitle(int level,int gender);
int QueryExp(int lev);
int QueryStatCost(string astat, int stat, object Player);
 
string zeige_reboot();
int liste();
static int compare(mixed *i, mixed *j);
mixed GetGuildSpells(int Art);
int show_all(string str);
int _kosten_();
void reduce_stat(string astat, int stat, object Player);
int set_max_stats(string str);
int join();
int leave(string argument);
int _advance_(string arg);
void ErhoeheAttribute(object Player,int stat,string astat, string long);
int ShowDescription(string name);
string EP_Message(object Player, string art);
 
#endif // __GUILD_SKILLS_H_PROTO__
#endif // NEED_PROTOYPES
 
 
