/*******************
** Eldarea MUDLib **
********************
**
** sys/properties.h - properties header file
**
** CVS DATA
** $Date: 2000/12/04 14:45:21 $
** $Revision: 1.2 $
**
** Hier sollten nur Properties sein, die nirgendwo anders sinnvoll hinpassen
**
** CVS History
**
** $Log: properties.h,v $
** Revision 1.2  2000/12/04 14:45:21  elatar
** obsolet defines removed
** new includes
**
** Revision 1.1.1.1  1999/11/05 12:30:48  elatar
** Preparing mudlib for cvs control
**
**
*/

#ifndef __PROPERTIES_H__
#define __PROPERTIES_H__
 
#ifdef NEED_PROTOTYPES
#undef NEED_PROTOTYPES		// we need only the properties here!!
#define TMP_NEED_PROTOTYPES
#endif

#include <snooping.h>
#include <thing.h>
#include <armour.h>
#include <container.h>
#include <living.h>
#include <humanoid.h>
#include <player.h>
#include <rooms.h>
#include <shells.h>
#include <weapon.h>
#include <transport.h>
#include <laden.h>
#include <inpc/interaction.h>

#ifdef TMP_NEED_PROTOTYPES
#undef TMP_NEED_PROTOTYPES
#define NEED_PROTOTYPES
#endif

#define P_CURSED "cursed"     // gehoert eigentlich in armour.h und weapon.h
			      // aber es waere dann doppelt definiert, also
			      // dann lieber hier...
//Obsolet
#define P_DC_NAME1 "dc_name1" // [Tod:] 'dc_name1' hat gerade xxx umgebracht.
#define P_DC_NAME2 "dc_name2" // [Tod:'dc_name2'] 'dc_msg'
#define P_DC_MSG "dc_msg"     // ist name2 nicht gesetzt wird der Wert von name1
		 	      // genommen.
#define P_SENSE              "wahrnehmung"
#define P_HIDE               "verbergung"
#define P_KILL_MSG           "kill_msg"
#define P_CORPSE             "corpse"
#define P_ENEMY_DEATH_SEQUENCE "enemy_death_sequence"
#define P_VALUE              "value"
#define P_FORCE_DEMONST      "force_demonst"
#define P_INFO               "info"
#define P_READ_MSG           "read_msg"
#define P_NOBUY              "nobuy"
#define P_NEVERDROP          "neverdrop"
#define P_WEIGHT_PERCENT     "weight_percent"
#define P_DETAILS            "details"
#define P_SPECIAL_DETAILS    "special_details"
#define P_READ_DETAILS       "read_details"
#define P_SOUND_DETAILS      "sound_details"
#define P_SMELL_DETAILS      "smell_details"
#define P_ITEMS              "items"
#define P_NO_TPORT           "tport"
#define P_INDOORS            "indoors"
#define P_NOMAGIC            "nomagic"
#define P_TIMEZONE           "timezone"
#define P_RACE               "race"
#define P_TOTAL_WC           "total_wc"
#define P_ZAP_MSG            "zap_msg"
#define P_REMOTECMDS         "remotecmds"
#define P_AWAY               "away"
#define P_WEAPONS            "weapons"
#define P_ARMOURS            "armours"
#define P_NPC                "is_npc"
#define P_WIMPY              "wimpy"
#define P_WIMPY_DIRECTION    "wimpy_dir"
#define P_HEAL               "heal"
#define P_POISON             "poison"
#define P_MAX_POISON         "max_poison"
#define P_DISABLE_ATTACK     "disable_attack"
#define P_DIE_MSG            "die_msg"
#define P_KILLS              "playerkills"
#define P_CALLED_FROM_IP     "called_from_ip"
#define P_DESCRIPTION        "description"
#define P_GUILD              "guild"
#define P_LEVEL              "level"
#define P_GUILD_LEVEL        "guild_level"
#define P_CAP_NAME           "cap_name"
#define P_EARMUFFS           "earmuffs"
#define P_MARRIED            "married"
#define P_AMOUNT             "amount"
#define P_VALUE_PER_UNIT     "value_per_unit"
#define P_WEIGHT_PER_UNIT    "weight_per_unit"
#define P_LIGHTDESC          "lightdesc"
#define P_DO_DESTRUCT        "do_destruct"
#define P_CHATS              "chats"
#define P_CHAT_CHANCE        "chat_chance"
#define P_ACHATS             "achats"
#define P_ACHAT_CHANCE       "achat_chance"
#define P_BODY               "body"
#define P_HB                 "hb"
#define P_AGGRESSIVE         "aggressive"
#define P_CANNOT_SEE_INVIS   "cannot_see_invis"   // unsichtbare werden nicht gesehen
#define P_CANT_BE_DISCOVERED "cant_be_discovered" // raum kann nicht erkundet werden
#define P_TELEPORT_FORBIDDEN "teleport_forbidden" // raum vor teleport_spruch geschuetzt
#define P_NOCORPSE           "nocorpse"
#define P_REJECT             "reject"
#define P_RACE_DESCRIPTION   "racedescr"
#define P_CONTAINER          "container"          // man kann was in uns reinstecken
#define P_TRAY               "tray"               // man kann was auf uns drauflegen
#define P_GIVEN_AMOUNT       "u_ga"               // Uebergebene Menge bei Unit-Objekten
#define P_PURSUERS           "pursuers"
#define P_HP_HOOKS           "hp_hooks"
#define P_SP_HOOKS           "sp_hooks"
#define P_MOVE_HOOKS         "move_hooks"

#define P_SPELLS             "spells"
#define P_SPELLRATE          "spellrate"

#define P_INFORMME           "informme"
#define P_WAITFOR            "waitfor"

#define P_LOCALCMDS          "localcmds"
#define P_NOSELL             "no_sell"
#define P_LIFETIME "lifetime"                     // fuer Schaden an Waffen
#define P_MAX_LIFETIME "max_lifetime"             // automatisch gesetzt

#define P_COINMASTER "coinmaster"
#define P_CURRENCY "currency"                    // Enthaelt den Namen der Waehrung
#define P_CHARACTER "character"                  // Charakterbeschreibung fuer Magier
#define P_EP_FUNC "ep_func"                      // Zeiger fuer NPC (siehe /doc/properties.h)
#define P_INVINCIBLE "invincible"                // NPC ist unangreifbar

#define P_SEE_LIGHT "see_light"                  // May see daylight from inside...

#define P_LOG_INFO "log_info"                    // sollen fehlende infos bei npc geloggt werden?
#define P_NIGHTVISION "nightvision"
#define P_UNSELLABLE "unsellable"                // Property fuer den 'markiere'-Befehl in base.c
#define P_WEAPONS_ALLOWED "allowed_weapon"       // darf ich Waffe zuecken???
#define P_ARMOURS_ALLOWED "allowed_armours"      // darf ich kleidung tragen???
#define P_DEATH "death"                          // anzahll der bisherigen tode
#define P_MURDER_MSG "murder_msg"                // Text der auf [Moerder] ausgegeben wird
#define P_CREATION_DATE "creation_date"          // Datum des ersten einloggens
#define P_NO_FIGHT_TEXT "no_fight_text"          // Metzeltext anzeigenlassen?

#define P_EP_FOR_SEER "ep_for_seer"              // Minimale EP-Grenze zum Seherwerden
#define P_TRANSPORT "transport"                  // Obj ist Transporter

#endif // __PROPERTIES_H__

